select
    an.numero as numero
  , ia.data as data
  , protpa.uso as nro_uso_cidr
  , rep.numero ||  coalesce(' ' || rep.nome, '') as REPRODUTOR
  , pes.nome as inseminador
  , program.sigla AS sigla_programacao
  , (case when (next.cdreproducao is not null) then '1' else '0' end) as CONTAGEM_PARA_CONCEPCAO_COM_DG
  , (case when (next.cdreproducao is null) then 'A'
      else (case when ((next.cdtiporeproducao = 7) or (next.diagnostico = 'P')) then '1' else null end) 
      end) as CONTAGEM_PARA_CONCEPCAO_POSITI
  , rep.numero as numero_touro
  , rep.nome as nome_touro
  , prottotal.descricao as nome_protocolo
from
  fazenda faz
  join animal an on 1 = 1
  join reproducao ia on ia.cdanimal = an.cdanimal
  left join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.cdtiporeproducao = 7 and re.data < ia.data
        order by re.data desc)
  left join reproducao iaant on iaant.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.cdtiporeproducao in (1,2,3) and re.data >
    coalesce(ultpar.data, '1900-01-01') and re.data < ia.data order by re.data desc)
  left join protocoloiatf prot on prot.cdprotocoloiatf = ia.cdprotocoloiatf and
    ((upper(prot.descricao) like '%TIPO%A%') or (upper(prot.descricao) like '%TIPO%B%') or (upper(prot.descricao) like '%TIPO%C%'))
  left join protocoloiatf prottotal on prottotal.cdprotocoloiatf = ia.cdprotocoloiatf
  left join protocoloiatfprincipioativo protpa on protpa.cdprotocoloiatfprincipioativo =
    (select first 1 re.cdprotocoloiatfprincipioativo from protocoloiatfprincipioativo re join principioativo repa on repa.cdprincipioativo
        = re.cdprincipioativo and upper(repa.nome) = 'PROGESTERONA' where re.cdprotocoloiatf = prot.cdprotocoloiatf order by re.uso asc)
  LEFT JOIN PROGRAMACAOIATF program ON program.cdprogramacaoiatf = ia.CDPROGRAMACAOIATF
    left join animal rep on rep.cdanimal = ia.cdreprodutor
  left join pessoa pes on pes.cdpessoa = ia.cdpessoa
  left join reproducao next on next.cdreproducao = 
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.data > ia.data 
      and ((re.cdtiporeproducao in (1,2,3,7)) or (re.cio in (1,2)) or (re.diagnostico is not null)) order by re.data asc)
  left join reproducao prox on prox.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.data > ia.data and
        ((re.cio in (1,2)) or (re.diagnostico is not null) or (re.cdtiporeproducao in (1,2,3,7))) order by re.data asc)
where
  ia.cdtiporeproducao = 1
and  next.cdreproducao is not null
and ia.data between 
---INFORMAR O INCIO DO PERODO NO FORMATO AAAA-MM-DD
'2000-01-01' 
and
---INFORMAR O FINAL DO PERODO NO FORMATO AAAA-MM-DD
'2030-12-31'
and program.sigla is not null
order by
  an.numordenado